package net.pocketmagic.android.scalingtest;

import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.ViewGroup.LayoutParams;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.support.v4.app.NavUtils;

public class MainActivity extends Activity {

	
	public Bitmap getScaledBitmap(Context context, float scalex, float scaley, int id) {
		Bitmap bitmap = BitmapFactory.decodeResource(context.getResources(), id);
		Matrix matrix = new Matrix();
		matrix.postScale(scalex, scaley);
		matrix.postRotate(0);
		Bitmap scaled =  Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(), bitmap.getHeight(), matrix, true);
		bitmap.recycle();
		return scaled;
	}
	public Drawable getScaledDrawable(Context context, float scalex, float scaley, int id) {
		return new BitmapDrawable(context.getResources(), getScaledBitmap(context, scalex, scaley, id));
	}

	public int Scale(int v, float scale) {
		float s = (float)v * scale; int rs = 0;
		
		if (s - (int)s >= 0.5) rs= ((int)s)+1; else rs= (int)s;
		
		return rs;
	}

	
    @Override public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        requestWindowFeature(Window.FEATURE_NO_TITLE);				
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,WindowManager.LayoutParams.FLAG_FULLSCREEN);
        
        RelativeLayout panel = new RelativeLayout(this);
        setContentView(panel);
        
     
        
        DisplayMetrics dm = new DisplayMetrics();
		getWindowManager().getDefaultDisplay().getMetrics(dm);
		int m_nTotalW = dm.widthPixels;
		int  m_nTotalH = dm.heightPixels;
		// scale factor
		float m_fFrameS = (float)m_nTotalH / 640.0f;
		// compute our frame
		int m_nFrameW = (int) (960.0f * m_fFrameS);
		int m_nFrameH = m_nTotalH;
		// compute padding for our frame inside the total screen size
		
		int m_nPaddingY = 0;
		int m_nPaddingX = (m_nTotalW - m_nFrameW) / 2;
		
        Log.d("ScaleTest", "Total:"+m_nTotalW + "x"+m_nTotalH+ " Scale:"+m_fFrameS+" Frame:"+m_nFrameW+"x"+m_nFrameH + " Padding:"+m_nPaddingX+"x"+m_nPaddingY);
        
        RelativeLayout frame = new RelativeLayout(this);
        frame.setBackgroundColor(Color.GRAY);
        RelativeLayout.LayoutParams lpv = new RelativeLayout.LayoutParams(m_nFrameW, m_nFrameH);
        lpv.leftMargin = m_nPaddingX ;
        lpv.topMargin = m_nPaddingY;
        panel.addView(frame, lpv);
        
        
        frame.setBackgroundDrawable(getResources().getDrawable(R.drawable.background_ui_android));
        
        /*ImageView iv = new ImageView(this);
        iv.setImageDrawable(getScaledDrawable(this, 
        		m_fFrameS, m_fFrameS, // same scaling factor on horizontal and on vertical 
        		R.drawable.flower_ui));
        lpv = new RelativeLayout.LayoutParams(
        		Scale(231,m_fFrameS), Scale(192, m_fFrameS));
        lpv.leftMargin =  Scale(410,m_fFrameS);
        lpv.topMargin = Scale(239,m_fFrameS);
        frame.addView(iv, lpv);*/
        
        ScalableImageView iv = new ScalableImageView(this, Scale(231,m_fFrameS), Scale(192, m_fFrameS));
        iv.setImageResource( R.drawable.flower_ui);
        lpv = new RelativeLayout.LayoutParams(Scale(231,m_fFrameS), Scale(192, m_fFrameS));
        lpv.leftMargin =  Scale(410,m_fFrameS);
        lpv.topMargin = Scale(239,m_fFrameS);
        frame.addView(iv, lpv);
        
    }


    
}
